#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#define MALLOC(tipo,num) ( (tipo*) malloc(num*sizeof(tipo)) )     

/////////////////////////////////////////////////////////

void Randomize();
double Random(double rmin, double rmax);

/////////////////////////////////////////////////////////

typedef struct{
  double *data;
  int size;
} Vector;

void initVector(Vector *v, int n);
void freeVector(Vector *v);
double norm2(Vector *v);
void fillVector(Vector *v,double rmin, double rmax);
void readVector(Vector *v,const char *filename);
void writeVector(Vector *v,const char *filename);
void gnuplotVector(Vector *x, Vector *v,const char *filename);
void printVector(Vector *v);
void resetVector(Vector *v);

/////////////////////////////////////////////////////////

typedef struct{
  double *data;
  int rows,cols;
  double **row;
} Matrix;

void initMatrix(Matrix *M, int n, int m);
void freeMatrix(Matrix *M);
void fillMatrix(Matrix *M,double rmin, double rmax);
void readMatrix(Matrix *M,const char *filename);
void writeMatrix(Matrix *M,const char *filename);
void gnuplotMatrix(Vector *x, Vector *y, Matrix *M, const char *filename);
void printMatrix(Matrix *M);
void resetMatrix(Matrix *M);

/////////////////////////////////////////////////////////

